package com.example.demo;

import org.springframework.http.MediaType
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

@RestController
class FooController(private val anyDocumentRepository: AnyDocumentRepository) {

    @PostMapping(value = ["/foo"], consumes = [MediaType.APPLICATION_JSON_VALUE])
    @Transactional(label = ["mongo:readPreference=PRIMARY"])
    fun foo(@RequestBody request: AnyDocumentRequest): Mono<Void> {
        return anyDocumentRepository.saveAll(request.list.map { AnyDocument(it.id) }).then()
    }
}